=== debian/changelog ===
drbd (9.0.31-1) unstable; urgency=low

  * New upstream release

 -- Philipp Reisner <phil@linbit.com>  Tue,  5 Oct 2021 08:37:02 +0100

drbd (9.0.30-1) unstable; urgency=low

  * New upstream release

 -- Philipp Reisner <phil@linbit.com>  Wed, 14 Jul 2021 10:43:09 +0100

drbd (9.0.29-1) unstable; urgency=low

  * New upstream release

 -- Philipp Reisner <phil@linbit.com>  Thu,  6 May 2021 09:39:07 +0100

drbd (9.0.28-1) unstable; urgency=low

  * New upstream release

 -- Philipp Reisner <phil@linbit.com>  Thu, 25 Feb 2021 17:18:21 +0100

drbd (9.0.27-1) unstable; urgency=low

  * New upstream release
  * Fix regression: allow live migration between two diskful peers again

 -- Lars Ellenberg <lars.ellenberg@linbit.com>  Wed, 23 Dec 2020 11:51:29 +0100

drbd (9.0.26-1) unstable; urgency=low

  * New upstream release

 -- Philipp Reisner <phil@linbit.com>  Tue, 22 Dec 2020 09:13:54 +0100

drbd (9.0.25-1) unstable; urgency=low

  * New upstream release

 -- Philipp Reisner <phil@linbit.com>  Tue, 22 Sep 2020 14:14:47 +0100

drbd (9.0.24-1) unstable; urgency=low

  * New upstream release

 -- Philipp Reisner <phil@linbit.com>  Mon, 29 Jun 2020 16:15:19 +0100

drbd (9.0.23-1) unstable; urgency=low

  * New upstream release

 -- Philipp Reisner <phil@linbit.com>  Mon, 08 Jun 2020 15:53:56 +0100

drbd (9.0.22-2) unstable; urgency=low

  * Fix reads on diskless in the presence of IO errors
  * Fix diskless nodes leaving a quorum enabled cluster

 -- Philipp Reisner <phil@linbit.com>  Mon, 30 Mar 2020 12:03:10 +0100

drbd (9.0.22-1) unstable; urgency=low

  * New upstream release

 -- Philipp Reisner <phil@linbit.com>  Tue, 10 Mar 2020 15:34:09 +0100

drbd (9.0.21-1) unstable; urgency=low

  * New upstream release

 -- Philipp Reisner <phil@linbit.com>  Mon, 12 Nov 2019 13:10:11 +0100

drbd (9.0.20-2) unstable; urgency=medium

  * New Debian release

 -- Roland Kammerer <roland.kammerer@linbit.com>  Fri, 11 Oct 2019 14:14:18 +0200

drbd (9.0.20-1) unstable; urgency=medium

  * New upstream release

 -- Philipp Reisner <phil@linbit.com>  Thu, 10 Oct 2019 09:12:38 +0200

drbd (9.0.19-1) unstable; urgency=medium

  * New upstream release

 -- Philipp Reisner <phil@linbit.com>  Mon, 08 Jul 2019 16:23:16 +0200

drbd (9.0.18.1-1) unstable; urgency=medium

  * New upstream release

 -- Lars Ellenberg <lars.ellenberg@linbit.com>  Fri, 31 May 2019 11:37:53 +0200

drbd (9.0.18-1) unstable; urgency=medium

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Fri, 24 May 2019 11:56:17 +0200

drbd (9.0.17-1) unstable; urgency=medium

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Tue, 26 Mar 2019 16:48:22 +0100

drbd (9.0.16-1) unstable; urgency=medium

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Thu, 25 Oct 2018 11:12:29 +0100

drbd (9.0.15-1) unstable; urgency=medium

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Tue, 14 Aug 2018 13:03:34 +0100

drbd (9.0.14-1) unstable; urgency=medium

  * New upstream release.

 -- Lars Ellenberg <lars.ellenberg@linbit.com>  Tue, 01 May 2018 00:12:39 +0200

drbd (9.0.13-1) unstable; urgency=medium

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Tue, 17 Apr 2018 10:30:07 +0100

drbd (9.0.12-1) unstable; urgency=medium

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Mon, 22 Jan 2018 13:24:51 +0100

drbd (9.0.11-1) unstable; urgency=medium

  * New upstream release.

 -- Roland Kammerer <roland.kammerer@linbit.com>  Tue, 09 Jan 2018 13:13:07 +0100

drbd (9.0.10-1) unstable; urgency=low

  * New upstream release.

 -- Roland Kammerer <rolan.kammerer@linbit.com>  Fri, 22 Dec 2017 13:02:11 +0100

drbd (9.0.9-1) unstable; urgency=low

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Thu, 31 Aug 2017 10:44:00 +0800

drbd (9.0.8-1) unstable; urgency=low

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Mon, 19 Jun 2017 15:27:42 +0800

drbd (9.0.7-1) unstable; urgency=low

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Fri, 31 Mar 2017 16:13:06 +0100

drbd (9.0.6-1) unstable; urgency=low

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Fri, 23 Dec 2016 13:02:18 +0100

drbd (9.0.5-1) unstable; urgency=low

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Thu, 20 Oct 2016 14:41:41 +0100

drbd (9.0.4-1) unstable; urgency=low

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Tue, 06 Sep 2016 15:36:13 +0100

drbd (9.0.3-1) unstable; urgency=low

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Thu, 14 Jul 2016 10:31:15 +0100

drbd (9.0.2-1) unstable; urgency=low

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Tue, 19 Apr 2016 15:38:10 +0100

drbd (9.0.1-1) unstable; urgency=low

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Tue, 02 Feb 2016 16:39:11 +0100

drbd (9.0.0-3) unstable; urgency=low

  * Fixes for the RDMA transport
  * Fixes for 8.4 compatibility
  * Rebuild after compat and build system fixes

 -- Lars Ellenberg <lars.ellenberg@linbit.com>  Tue, 28 Jul 2015 17:22:34 +0200

drbd (9.0.0-1) unstable; urgency=low

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Tue, 16 Jun 2015 13:53:29 +0200

drbd (9.0.0rc3-1) unstable; urgency=low

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Wed, 13 May 2015 13:19:33 +0200

drbd (9.0.0rc2-1) unstable; urgency=low

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Thu,  6 Mar 2015 11:29:00 +0200

drbd (9.0.0rc1-1) unstable; urgency=low

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Tue, 20 Jan 2015 14:00:00 +0200

drbd (9.0.0pre10-1) unstable; urgency=low

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Fri, 19 Sep 2014 21:26:13 +0200

drbd (9.0.0pre9-1) unstable; urgency=low

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Fri,  7 Mar 2014 17:31:00 +0200
