=== debian/control ===
Source: drbd
Section: admin
Priority: extra
Maintainer: DRBD dev <drbd-dev@lists.linbit.com>
Uploaders: Philipp Reisner <phil@linbit.com>,
           Lars Ellenberg <lars@linbit.com>,
           Roland Kammerer <roland.kammerer@linbit.com>
Build-Depends: bash,
               debhelper (>= 7),
               dkms
Standards-Version: 3.6.2.1

Package: drbd-dkms
Architecture: all
Section: admin
Depends: debhelper (>=7),
         dkms (>= 1.9.5),
         drbd-utils (>= 9.2.0),
         curl,
         ${misc:Depends}
Conflicts: drbd-module-source,
           drbd8-module-source
Provides: drbd-dkms
Replaces: drbd-module-source
Description: RAID 1 over TCP/IP for Linux module source
 DRBD is a block device which is designed to build high availability
 clusters by providing a virtual shared device which keeps disks in
 nodes synchronised using TCP/IP. This simulates RAID 1 but avoiding
 the use of uncommon hardware (shared SCSI buses or Fibre Channel).
 It is currently limited to fail-over HA clusters.
 .
 This package contains the source code for the DRBD kernel module.
Homepage: http://www.drbd.org

Package: drbd-module-source
Architecture: all
Section: admin
Depends: debhelper (>= 7),
         ${misc:Depends}
Conflicts: drbd-dkms,
           drbd8-module-source
Provides: drbd-module-source
Replaces: drbd-dkms
Recommends: kernel-package | module-assistant
Description: RAID 1 over TCP/IP for Linux module source
 DRBD is a block device which is designed to build high availability
 clusters by providing a virtual shared device which keeps disks in
 nodes synchronised using TCP/IP. This simulates RAID 1 but avoiding
 the use of uncommon hardware (shared SCSI buses or Fibre Channel).
 It is currently limited to fail-over HA clusters.
 .
 This package contains the source code for the DRBD kernel module.
Homepage: http://www.drbd.org
