=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

VERSION := $(shell dpkg-parsechangelog | sed -rne 's/^Version: ([0-9]+:)?//p')
PACKAGE=drbd-module
DKMSDIR=drbd-dkms
MODSRCDIR=drbd-module-source

# modifieable for experiments or debugging m-a
MA_DIR ?= /usr/share/modass
# load generic variable handling
-include $(MA_DIR)/include/generic.make
# load default rules, including kdist, kdist_image, ...
-include $(MA_DIR)/include/common-rules.make

%:
	dh $@ --with dkms

override_dh_auto_clean: ;
override_dh_auto_configure: ;
override_dh_auto_build: ;
override_dh_auto_test: ;
override_dh_auto_install: ;

override_dh_install:
	# dkms
	dh_install drbd ../$(DKMSDIR)/usr/src/drbd-$(VERSION)/src

	# m-a
	dh_install drbd ../$(MODSRCDIR)/usr/src/modules/drbd/
	dh_install misc/SECURE-BOOT-KEY-linbit.com.der ../$(MODSRCDIR)/usr/src/modules/drbd/misc
	dh_install debian/changelog ../$(MODSRCDIR)/usr/src/modules/drbd/debian
	dh_install debian/control ../$(MODSRCDIR)/usr/src/modules/drbd/debian
	dh_install debian/compat ../$(MODSRCDIR)/usr/src/modules/drbd/debian
	dh_install debian/copyright ../$(MODSRCDIR)/usr/src/modules/drbd/debian
	dh_install debian/*modules.in ../$(MODSRCDIR)/usr/src/modules/drbd/debian
	dh_install debian/rules ../$(MODSRCDIR)/usr/src/modules/drbd/debian
	cd debian/$(MODSRCDIR)/usr/src ; tar pzfvc drbd.tar.gz modules ; rm -rf modules
	install -m 755 debian/modass.drbd-module-source ./debian/$(MODSRCDIR)/usr/share/modass/overrides/$(MODSRCDIR)

override_dh_dkms:
	dh_dkms -V $(VERSION)

# some nasty clue code for m-a
kdist_clean:
	dh_clean
	-$(MAKE) -C drbd clean

DEB_BUILD_ARCH := $(shell dpkg --print-architecture)
binary-modules: prep-deb-files
	dh_testdir
	dh_testroot
	dh_clean -k
	$(MAKE) -C drbd KERNEL_SOURCES=$(KSRC) MODVERSIONS=detect KERNEL=linux-$(KVERS) KDIR=$(KSRC)
	$(MAKE) -C $(KSRC) M=$(CURDIR)/drbd modules_install INSTALL_MOD_PATH=$(CURDIR)/debian/$(PKGNAME) INSTALL_MOD_DIR=updates CONFIG_MODULE_SIG_ALL=y CONFIG_MODULE_SIG_KEY=certs/signing_key.pem
	install -m644 -b -D misc/SECURE-BOOT-KEY-linbit.com.der $(CURDIR)/debian/$(PKGNAME)/etc/pki/linbit/SECURE-BOOT-KEY-linbit.com.der
	install -m644 -b -D drbd/Module.symvers $(DEB_DESTDIR)/Module.symvers.$(KVERS).$(DEB_BUILD_ARCH)
	dh_installdocs
	dh_installchangelogs
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_gencontrol -- -v$(VERSION)
	dh_md5sums
	dh_builddeb --destdir=$(DEB_DESTDIR)
